; 
; Formatting a number with thousand separator using various methods
; 

INCLUDE \masm32\include\masm32rt.inc

; 
; Macro to convert an unsigned long integer into a string
; 

ustrv$ MACRO DDvalue1, DDvalue2   ;; unsigned integer to string
     invoke crt__ultoa,DDvalue1,DDvalue2,10
     EXITM <offset DDvalue2>
ENDM

NumChars = 20 ; Len of the String to contain unformatted number

; 
; Data Area
; 

.DATA

Num        dword 3365417345         ; Number to format 
NumStr     byte  NumChars dup(0)    ; String where wsprintf() will return
                                    ; the converted number
PtrNumStr  dword  NumStr            ; Pointer to the String containing 
                                    ; unformatted  number                       
NumForm    byte NumChars dup(0)     ; String for the formatted number with
                                    ; thousand separator 
PtrNumForm dword  NumForm           ; Pointer to the String containing                                                    
                                    ; the formatted number

ThouSep    byte   '.'               ; European thousand separator
OneByte    byte   0
    
.DATA?


; 
; Code Area
; 

.CODE

main   PROC

; 
; Converts the number into a string using a CRT function
; called by a MACRO
;  

        mov PtrNumStr, ustrv$(Num, offset NumStr)

; 
; Inserts thousand separator into the string using the stack
;  

        mov ecx, NumChars         ; Max number of chars into the string
        mov esi, PtrNumStr        ; address of unformatted string
        mov edi, PtrNumForm       ; address of formatted string
        xor ebx, ebx
        xor edx, edx

Pushing:

        mov  dl, [esi]
        cmp  dl, 0
        jz   Popping
        push dx  
        inc  esi      
        dec  ecx
        jnz  Pushing

Popping:

        mov  ebx, NumChars 
        sub  ebx, ecx
        mov  ecx, ebx
        xor  ebx, ebx

LetsPop:

        pop  dx 
        mov  [edi], dl
        inc  ebx
        cmp  ebx, 3
        jne  CarryOn
        xor  ebx, ebx
        mov  dl, ThouSep
        inc  edi
        mov  [edi], dl
  

CarryOn:

        inc  edi
        dec  ecx
        jnz  LetsPop
        mov  dl, 0
        mov  [edi], dl
       
; display results

        print " The original string: "
        print PtrNumStr,13,10,13,10

        print " The reversed/formatted string: "
        print PtrNumForm,13,10,13,10
        mov PtrNumForm, rev$(PtrNumForm)

        print " The rereversed/formatted string: "
        print PtrNumForm,13,10,13,10
        



; 
; Waits for a keypress and terminate the program
; 

        inkey   " Press any key to close..."
        invoke  ExitProcess, 0


main   ENDP

; 
;  Any PROC comes here
; 



; 
END     main
; 